# Makefile.nmake
# nmake file for Wireshark plugin
#

include ..\..\..\config.nmake
include <win32.mak>
include moduleinfo.nmake

# General part
CFLAGS=/WX /DHAVE_CONFIG_H /I../../.. /I../../../wiretap $(GLIB_CFLAGS) \
	/I$(PCAP_DIR)\include -D_U_="" $(LOCAL_CFLAGS)

LDFLAGS = $(PLUGIN_LDFLAGS)

!IFDEF ENABLE_LIBWIRESHARK
LINK_PLUGIN_WITH=..\..\libwireshark.lib ..\dissectors.lib
CFLAGS=/DHAVE_WIN32_LIBWIRESHARK_LIB /D_NEED_VAR_IMPORT_ $(CFLAGS)

DISSECTOR_OBJECTS = $(PACKAGE_SRC:.c=.obj)

DISSECTOR_SUPPORT_OBJECTS = $(DISSECTOR_SUPPORT_SRC:.c=.obj)

OBJECTS = $(DISSECTOR_OBJECTS) $(DISSECTOR_SUPPORT_OBJECTS) plugin.obj

RESOURCE=$(PACKAGE).res

all: $(PACKAGE).dll

MODULE_VERSION=$(MODULE_VERSION_MAJOR).$(MODULE_VERSION_MINOR).$(MODULE_VERSION_MICRO)
RC_MODULE_VERSION=$(MODULE_VERSION_MAJOR),$(MODULE_VERSION_MINOR),$(MODULE_VERSION_MICRO)

PRODUCT_VERSION=$(MODULE_VERSION_MAJOR).$(MODULE_VERSION_MINOR)
RC_PRODUCT_VERSION=$(MODULE_VERSION_MAJOR),$(MODULE_VERSION_MINOR)

API_VERSION=$(API_VERSION_MAJOR).$(API_VERSION_MINOR)
WIRESHARK_VERSION=$(VERSION_MAJOR).$(VERSION_MINOR)

$(PACKAGE).rc : moduleinfo.nmake
	sed -e s/@PACKAGE@/$(PACKAGE)/ \
	-e s/@RC_MODULE_VERSION@/$(RC_MODULE_VERSION)/ \
	-e s/@RC_PRODUCT_VERSION@/$(RC_PRODUCT_VERSION)/ \
	-e s/@RC_VERSION@/$(RC_VERSION)/ \
	-e s/@MODULE_VERSION@/$(MODULE_VERSION)/ \
	-e s/@PRODUCT_VERSION@/$(PRODUCT_VERSION)/ \
	-e s/@PACKAGE@/$(PACKAGE)/ \
	-e s/@PACKAGE_DIS@/$(PACKAGE_DIS)/ \
	-e s/@WIRESHARK_VERSION@/$(WIRESHARK_VERSION)/ \
	-e s/@AUTHOR@/$(AUTHOR)/ \
	-e s/@API_VERSION@/$(API_VERSION)/ \
	-e s/@COMPANY_CR@/$(COMPANY_CR)/ \
	-e s/@YEAR_CR@/$(YEAR_CR)/ \
	-e s/@MSVC_VARIANT@/$(MSVC_VARIANT)/ \
	< plugin.rc.in > $@

$(PACKAGE).dll $(PACKAGE).exp $(PACKAGE).lib : $(OBJECTS) $(LINK_PLUGIN_WITH) $(RESOURCE)
	link -dll /out:$(PACKAGE).dll $(LDFLAGS) $(OBJECTS) $(LINK_PLUGIN_WITH) \
	$(GLIB_LIBS) $(RESOURCE)


plugin.c: $(PACKAGE_SRC) ../../../tools/make-dissector-reg.py ../../../tools/make-dissector-reg
!IFDEF PYTHON
	@echo Making plugin.c (using python)
	@$(PYTHON) "../../../tools/make-dissector-reg.py" . plugin $(PACKAGE_SRC)
!ELSE
	@echo Making plugin.c (using sh)
	@$(SH) ../../../tools/make-dissector-reg . plugin $(PACKAGE_SRC)
!ENDIF

!ENDIF

clean:
	rm -f $(OBJECTS) $(RESOURCE) plugin.c *.pdb \
	    $(PACKAGE).dll $(PACKAGE).dll.manifest $(PACKAGE).lib \
	    $(PACKAGE).exp

distclean: clean

maintainer-clean: distclean
